/**
* graf-foundation v0.0.1
* author: Nic Chan
* https://github.com/chenyucai/graf-foundation.git
* Released under the MIT License.
*/
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("store")):"function"==typeof define&&define.amd?define(["exports","store"],e):e(t.GrafFoundation=t.GrafFoundation||{},t.store)}(this,function(t,r){"use strict";r="default"in r?r.default:r;var e={isBlank:function(t){return""===t||null==t},toArray:function(t){var e=1<arguments.length&&void 0!==arguments[1]?arguments[1]:",";return t.split(e)}};var n={isArray:function(t){return t&&"[object Array]"==={}.toString.call(t)},isNullOrEmpty:function(t){return null===t||0===t.length},toString:function(t){var e=1<arguments.length&&void 0!==arguments[1]?arguments[1]:",";return t.join(e)},add:function(t,e){return t.push(e)},remove:function(t,e){var r=t.findIndex(function(t){return t===e});return-1<r&&t.splice(r,1),t},removeAt:function(t,e){return t.splice(e,1)},contains:function(t,e){return-1<t.findIndex(function(t){return t===e})}},o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},i=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")},s=function(){function n(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(t,e,r){return e&&n(t.prototype,e),r&&n(t,r),t}}(),a=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var r=arguments[e];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(t[n]=r[n])}return t},u=function(t){if(Array.isArray(t)){for(var e=0,r=Array(t.length);e<t.length;e++)r[e]=t[e];return r}return Array.from(t)};var c={format:
/**
 * 日期对象转换为指定格式的字符串
 * @param formatStr 日期格式,格式定义如下 yyyy-MM-dd HH:mm:ss
 * @param date Date日期对象, 如果缺省，则为当前时间
 * YYYY/yyyy/YY/yy 表示年份
 * MM/M 月份
 * W/w 星期
 * dd/DD/d/D 日期
 * hh/HH/h/H 时间
 * mm/m 分钟
 * ss/SS/s/S 秒
 * @return string 指定格式的时间字符串
 */
function(t,e){t=t||"yyyy-MM-dd HH:mm:ss",e=e||new Date;var r=t;return r=(r=(r=(r=(r=(r=(r=(r=(r=(r=(r=(r=(r=r.replace(/yyyy|YYYY/,e.getFullYear())).replace(/yy|YY/,9<e.getYear()%100?(e.getYear()%100).toString():"0"+e.getYear()%100)).replace(/MM/,9<e.getMonth()+1?e.getMonth()+1:"0"+(e.getMonth()+1))).replace(/M/g,e.getMonth()+1)).replace(/w|W/g,["日","一","二","三","四","五","六"][e.getDay()])).replace(/dd|DD/,9<e.getDate()?e.getDate().toString():"0"+e.getDate())).replace(/d|D/g,e.getDate())).replace(/hh|HH/,9<e.getHours()?e.getHours().toString():"0"+e.getHours())).replace(/h|H/g,e.getHours())).replace(/mm/,9<e.getMinutes()?e.getMinutes().toString():"0"+e.getMinutes())).replace(/m/g,e.getMinutes())).replace(/ss|SS/,9<e.getSeconds()?e.getSeconds().toString():"0"+e.getSeconds())).replace(/s|S/g,e.getSeconds())}
/**
 * 通过偏移量查日期
 * @param offset 0 代表当天
 * @param date - yyyy-MM-dd 表示以哪个日期开始计算
 * @return string - yyyy-MM-dd
 */,getDateByOffset:function(t,e){var r=void 0,n=t||0;(r=e?new Date(e):new Date).setDate(r.getDate()+n);var i=r.getFullYear(),o=r.getMonth()+1,s=r.getDate();function a(t){return(t=parseInt(t))<10?"0"+t:t}return i+"-"+a(o)+"-"+a(s)}
/**
 * number类型日期转字符串
 * @param dateNum
 * @param formatStr
 * @returns {*}
 */,numberToString:function(t,e){if(!t)return null;e=e||"-";var r=t.toString();return r.substr(0,4)+e+r.substr(4,2)+e+r.substr(6,2)}
/**
 * 字符串类型转number
 * @param dateStr - 格式 yyyy-MM-dd
 * @return number
 */,stringToNumber:function(t){return parseInt(t.replace(/-/g,""))}
/**
 * 字符串转换为日期对象
 * @param dateStr - 格式为yyyy-MM-dd HH:mm:ss，必须按年月日时分秒的顺序，中间分隔符不限制
 */,stringToDate:function(t){var e=t.match(/(\d{1,4})/gm);e[1]=e[1]-1;var r=e.map(function(t){return parseInt(t)});return new(Function.prototype.bind.apply(Date,[null].concat(u(r))))}
/**
 * 日期对象转换为毫秒数
 * @param date - 日期对象
 */,dateToLong:function(t){return t.getTime()}
/**
 * 毫秒转换为日期对象
 * @param long - 日期的毫秒数
 */,longToDate:function(t){return new Date(t)}
/**
 * 取得当前日期所在月的最大天数
 */,maxDayOfDate:function(t){(t=t||new Date).setDate(1),t.setMonth(t.getMonth()+1);var e=t.getTime()-864e5;return new Date(e).getDate()}};var h={uuid:function(t,e){var r="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split(""),n=[],i=void 0;if(t)for(e=e||r.length,i=0;i<t;i++)n[i]=r[0|Math.random()*e];else{var o=void 0;for(n[8]=n[13]=n[18]=n[23]="-",n[14]="4",i=0;i<36;i++)n[i]||(o=0|16*Math.random(),n[i]=r[19===i?3&o|8:o])}return n.join("")},getKeyOfPair:function(t){return t?t.key:null},getValueOfPair:function(t){return t?t.value:null},downloadFile:function(t){var e={};e.iframe||(e.iframe=document.createElement("iframe"),document.body.appendChild(e.iframe)),e.iframe.src=t,e.iframe.style.display="none"},getClientWidth:function(){return document.documentElement.clientWidth||document.body.clientWidth},getClientHeight:function(){return document.documentElement.clientHeight||document.body.clientHeight},setPageTitle:function(e){
// 解决ios上不能设置title的问题
setTimeout(function(){
// 利用iframe的onload事件刷新页面
document.title=e;var t=document.createElement("iframe");t.src="/favicon.ico",// 必须
t.style.visibility="hidden",t.style.width="1px",t.style.height="1px",t.onload=function(){setTimeout(function(){document.body.removeChild(t)},0)},document.body.appendChild(t)},0)},createObjectURL:function(t){return(window.URL||window.webkitURL).createObjectURL(t)}};var f={toJSONString:function(t){return JSON.stringify(t)},parseObject:function(t){return JSON.parse(t)}};var d={isObject:function(t){return t&&"[object Object]"==={}.toString.call(t)},isNullOrEmpty:function(t){if(null==t)return!0;for(var e in t)if(t.hasOwnProperty(e))return!1;return!0},deepCopy:function(t){if(null===t)return t;if("object"!==(void 0===t?"undefined":o(t)))return t;var e="[object Array]"==={}.toString.call(t)?[]:{};for(var r in t)t.hasOwnProperty(r)&&(e[r]="object"===o(t[r])?this.deepCopy(t[r]):t[r]);return e}};var l={get:function(t){return r.get(t)},set:function(t,e){return r.set(t,e)},remove:function(t){return r.remove(t)},clearAll:function(){return r.clearAll()}};
/* eslint-disable */function g(){for(var t=0,e={};t<arguments.length;t++){var r=arguments[t];for(var n in r)e[n]=r[n]}return e}var m=function t(l){function m(t,e,r){var n;if("undefined"!=typeof document){
// Write
if(1<arguments.length){if("number"==typeof(r=g({path:"/"},m.defaults,r)).expires){var i=new Date;i.setMilliseconds(i.getMilliseconds()+864e5*r.expires),r.expires=i}
// We're using "expires" because "max-age" is not supported by IE
r.expires=r.expires?r.expires.toUTCString():"";try{n=JSON.stringify(e),/^[\{\[]/.test(n)&&(e=n)}catch(t){}e=l.write?l.write(e,t):encodeURIComponent(String(e)).replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g,decodeURIComponent),t=(t=(t=encodeURIComponent(String(t))).replace(/%(23|24|26|2B|5E|60|7C)/g,decodeURIComponent)).replace(/[\(\)]/g,escape);var o="";for(var s in r)r[s]&&(o+="; "+s,!0!==r[s]&&(o+="="+r[s]));return document.cookie=t+"="+e+o}
// Read
t||(n={});
// To prevent the for loop in the first place assign an empty array
// in case there are no cookies at all. Also prevents odd result when
// calling "get()"
for(var a=document.cookie?document.cookie.split("; "):[],u=/(%[0-9A-Z]{2})+/g,c=0;c<a.length;c++){var h=a[c].split("="),f=h.slice(1).join("=");'"'===f.charAt(0)&&(f=f.slice(1,-1));try{var d=h[0].replace(u,decodeURIComponent);if(f=l.read?l.read(f,d):l(f,d)||f.replace(u,decodeURIComponent),this.json)try{f=JSON.parse(f)}catch(t){}if(t===d){n=f;break}t||(n[d]=f)}catch(t){}}return n}}return(m.set=m).get=function(t){return m.call(m,t)},m.getJSON=function(){return m.apply({json:!0},[].slice.call(arguments))},m.defaults={},m.remove=function(t,e){m(t,"",g(e,{expires:-1}))},m.withConverter=t,m}(function(){}),_=1,p="",y={hex_md5:function(t){return this.rstr2hex(this.rstr_md5(this.str2rstr_utf8(t)))},b64_md5:function(t){return this.rstr2b64(this.rstr_md5(this.str2rstr_utf8(t)))},any_md5:function(t,e){return this.rstr2any(this.rstr_md5(this.str2rstr_utf8(t)),e)},hex_hmac_md5:function(t,e){return this.rstr2hex(this.rstr_hmac_md5(this.str2rstr_utf8(t),this.str2rstr_utf8(e)))},b64_hmac_md5:function(t,e){return this.rstr2b64(this.rstr_hmac_md5(this.str2rstr_utf8(t),this.str2rstr_utf8(e)))},any_hmac_md5:function(t,e,r){return this.rstr2any(this.rstr_hmac_md5(this.str2rstr_utf8(t),this.str2rstr_utf8(e)),r)},
/*
   * Calculate the MD5 of a raw string
   */
rstr_md5:function(t){return this.binl2rstr(this.binl_md5(this.rstr2binl(t),8*t.length))},
/*
   * Calculate the HMAC-MD5, of a key and some data (raw strings)
   */
rstr_hmac_md5:function(t,e){var r=this.rstr2binl(t);16<r.length&&(r=this.binl_md5(r,8*t.length));for(var n=Array(16),i=Array(16),o=0;o<16;o++)n[o]=909522486^r[o],i[o]=1549556828^r[o];var s=this.binl_md5(n.concat(this.rstr2binl(e)),512+8*e.length);return this.binl2rstr(this.binl_md5(i.concat(s),640))},
/*
   * Convert a raw string to a hex string
   */
rstr2hex:function(t){for(var e,r=_?"0123456789ABCDEF":"0123456789abcdef",n="",i=0;i<t.length;i++)e=t.charCodeAt(i),n+=r.charAt(e>>>4&15)+r.charAt(15&e);return n},
/*
   * Convert a raw string to a base-64 string
   */
rstr2b64:function(t){for(var e="",r=t.length,n=0;n<r;n+=3)for(var i=t.charCodeAt(n)<<16|(n+1<r?t.charCodeAt(n+1)<<8:0)|(n+2<r?t.charCodeAt(n+2):0),o=0;o<4;o++)8*n+6*o>8*t.length?e+=p:e+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(i>>>6*(3-o)&63);return e},
/*
   * Convert a raw string to an arbitrary string encoding
   */
rstr2any:function(t,e){var r,n,i,o,s,a=e.length,u=Array(Math.ceil(t.length/2));for(r=0;r<u.length;r++)u[r]=t.charCodeAt(2*r)<<8|t.charCodeAt(2*r+1);
/*
     * Repeatedly perform a long division. The binary array forms the dividend,
     * the length of the encoding is the divisor. Once computed, the quotient
     * forms the dividend for the next step. All remainders are stored for later
     * use.
     */var c=Math.ceil(8*t.length/(Math.log(e.length)/Math.log(2))),h=Array(c);for(n=0;n<c;n++){for(s=Array(),r=o=0;r<u.length;r++)o=(o<<16)+u[r],o-=(i=Math.floor(o/a))*a,(0<s.length||0<i)&&(s[s.length]=i);h[n]=o,u=s}
/* Convert the remainders to the output string */var f="";for(r=h.length-1;0<=r;r--)f+=e.charAt(h[r]);return f},
/*
   * Encode a string as utf-8.
   * For efficiency, this assumes the input is valid utf-16.
   */
str2rstr_utf8:function(t){for(var e,r,n="",i=-1;++i<t.length;)
/* Decode utf-16 surrogate pairs */
e=t.charCodeAt(i),r=i+1<t.length?t.charCodeAt(i+1):0,55296<=e&&e<=56319&&56320<=r&&r<=57343&&(e=65536+((1023&e)<<10)+(1023&r),i++)
/* Encode output as utf-8 */,e<=127?n+=String.fromCharCode(e):e<=2047?n+=String.fromCharCode(192|e>>>6&31,128|63&e):e<=65535?n+=String.fromCharCode(224|e>>>12&15,128|e>>>6&63,128|63&e):e<=2097151&&(n+=String.fromCharCode(240|e>>>18&7,128|e>>>12&63,128|e>>>6&63,128|63&e));return n},
/*
   * Encode a string as utf-16
   */
str2rstr_utf16le:function(t){for(var e="",r=0;r<t.length;r++)e+=String.fromCharCode(255&t.charCodeAt(r),t.charCodeAt(r)>>>8&255);return e},str2rstr_utf16be:function(t){for(var e="",r=0;r<t.length;r++)e+=String.fromCharCode(t.charCodeAt(r)>>>8&255,255&t.charCodeAt(r));return e},
/*
   * Convert a raw string to an array of little-endian words
   * Characters >255 have their high-byte silently ignored.
   */
rstr2binl:function(t){for(var e=Array(t.length>>2),r=0;r<e.length;r++)e[r]=0;for(r=0;r<8*t.length;r+=8)e[r>>5]|=(255&t.charCodeAt(r/8))<<r%32;return e},
/*
   * Convert an array of little-endian words to a string
   */
binl2rstr:function(t){for(var e="",r=0;r<32*t.length;r+=8)e+=String.fromCharCode(t[r>>5]>>>r%32&255);return e},
/*
   * Calculate the MD5 of an array of little-endian words, and a bit length.
   */
binl_md5:function(t,e){
/* append padding */
t[e>>5]|=128<<e%32,t[14+(e+64>>>9<<4)]=e;for(var r=1732584193,n=-271733879,i=-1732584194,o=271733878,s=0;s<t.length;s+=16){var a=r,u=n,c=i,h=o;r=this.md5_ff(r,n,i,o,t[s+0],7,-680876936),o=this.md5_ff(o,r,n,i,t[s+1],12,-389564586),i=this.md5_ff(i,o,r,n,t[s+2],17,606105819),n=this.md5_ff(n,i,o,r,t[s+3],22,-1044525330),r=this.md5_ff(r,n,i,o,t[s+4],7,-176418897),o=this.md5_ff(o,r,n,i,t[s+5],12,1200080426),i=this.md5_ff(i,o,r,n,t[s+6],17,-1473231341),n=this.md5_ff(n,i,o,r,t[s+7],22,-45705983),r=this.md5_ff(r,n,i,o,t[s+8],7,1770035416),o=this.md5_ff(o,r,n,i,t[s+9],12,-1958414417),i=this.md5_ff(i,o,r,n,t[s+10],17,-42063),n=this.md5_ff(n,i,o,r,t[s+11],22,-1990404162),r=this.md5_ff(r,n,i,o,t[s+12],7,1804603682),o=this.md5_ff(o,r,n,i,t[s+13],12,-40341101),i=this.md5_ff(i,o,r,n,t[s+14],17,-1502002290),n=this.md5_ff(n,i,o,r,t[s+15],22,1236535329),r=this.md5_gg(r,n,i,o,t[s+1],5,-165796510),o=this.md5_gg(o,r,n,i,t[s+6],9,-1069501632),i=this.md5_gg(i,o,r,n,t[s+11],14,643717713),n=this.md5_gg(n,i,o,r,t[s+0],20,-373897302),r=this.md5_gg(r,n,i,o,t[s+5],5,-701558691),o=this.md5_gg(o,r,n,i,t[s+10],9,38016083),i=this.md5_gg(i,o,r,n,t[s+15],14,-660478335),n=this.md5_gg(n,i,o,r,t[s+4],20,-405537848),r=this.md5_gg(r,n,i,o,t[s+9],5,568446438),o=this.md5_gg(o,r,n,i,t[s+14],9,-1019803690),i=this.md5_gg(i,o,r,n,t[s+3],14,-187363961),n=this.md5_gg(n,i,o,r,t[s+8],20,1163531501),r=this.md5_gg(r,n,i,o,t[s+13],5,-1444681467),o=this.md5_gg(o,r,n,i,t[s+2],9,-51403784),i=this.md5_gg(i,o,r,n,t[s+7],14,1735328473),n=this.md5_gg(n,i,o,r,t[s+12],20,-1926607734),r=this.md5_hh(r,n,i,o,t[s+5],4,-378558),o=this.md5_hh(o,r,n,i,t[s+8],11,-2022574463),i=this.md5_hh(i,o,r,n,t[s+11],16,1839030562),n=this.md5_hh(n,i,o,r,t[s+14],23,-35309556),r=this.md5_hh(r,n,i,o,t[s+1],4,-1530992060),o=this.md5_hh(o,r,n,i,t[s+4],11,1272893353),i=this.md5_hh(i,o,r,n,t[s+7],16,-155497632),n=this.md5_hh(n,i,o,r,t[s+10],23,-1094730640),r=this.md5_hh(r,n,i,o,t[s+13],4,681279174),o=this.md5_hh(o,r,n,i,t[s+0],11,-358537222),i=this.md5_hh(i,o,r,n,t[s+3],16,-722521979),n=this.md5_hh(n,i,o,r,t[s+6],23,76029189),r=this.md5_hh(r,n,i,o,t[s+9],4,-640364487),o=this.md5_hh(o,r,n,i,t[s+12],11,-421815835),i=this.md5_hh(i,o,r,n,t[s+15],16,530742520),n=this.md5_hh(n,i,o,r,t[s+2],23,-995338651),r=this.md5_ii(r,n,i,o,t[s+0],6,-198630844),o=this.md5_ii(o,r,n,i,t[s+7],10,1126891415),i=this.md5_ii(i,o,r,n,t[s+14],15,-1416354905),n=this.md5_ii(n,i,o,r,t[s+5],21,-57434055),r=this.md5_ii(r,n,i,o,t[s+12],6,1700485571),o=this.md5_ii(o,r,n,i,t[s+3],10,-1894986606),i=this.md5_ii(i,o,r,n,t[s+10],15,-1051523),n=this.md5_ii(n,i,o,r,t[s+1],21,-2054922799),r=this.md5_ii(r,n,i,o,t[s+8],6,1873313359),o=this.md5_ii(o,r,n,i,t[s+15],10,-30611744),i=this.md5_ii(i,o,r,n,t[s+6],15,-1560198380),n=this.md5_ii(n,i,o,r,t[s+13],21,1309151649),r=this.md5_ii(r,n,i,o,t[s+4],6,-145523070),o=this.md5_ii(o,r,n,i,t[s+11],10,-1120210379),i=this.md5_ii(i,o,r,n,t[s+2],15,718787259),n=this.md5_ii(n,i,o,r,t[s+9],21,-343485551),r=this.safe_add(r,a),n=this.safe_add(n,u),i=this.safe_add(i,c),o=this.safe_add(o,h)}return Array(r,n,i,o)},
/*
   * These functions implement the four basic operations the algorithm uses.
   */
md5_cmn:function(t,e,r,n,i,o){return this.safe_add(this.bit_rol(this.safe_add(this.safe_add(e,t),this.safe_add(n,o)),i),r)},md5_ff:function(t,e,r,n,i,o,s){return this.md5_cmn(e&r|~e&n,t,e,i,o,s)},md5_gg:function(t,e,r,n,i,o,s){return this.md5_cmn(e&n|r&~n,t,e,i,o,s)},md5_hh:function(t,e,r,n,i,o,s){return this.md5_cmn(e^r^n,t,e,i,o,s)},md5_ii:function(t,e,r,n,i,o,s){return this.md5_cmn(r^(e|~n),t,e,i,o,s)},
/*
   * Add integers, wrapping at 2^32. This uses 16-bit operations internally
   * to work around bugs in some JS interpreters.
   */
safe_add:function(t,e){var r=(65535&t)+(65535&e);return(t>>16)+(e>>16)+(r>>16)<<16|65535&r},
/*
   * Bitwise rotate a 32-bit number to the left.
   */
bit_rol:function(t,e){return t<<e|t>>>32-e}},v=function(){function t(){i(this,t)}return s(t,[{key:"map",value:function(t){var e=this.constructor.__checkers__;for(var r in this){if(!this.hasOwnProperty(r))return;e&&e[r]&&t[r]&&e[r].type!==this._getTypeOfValue(t[r])&&"development"===process.env.NODE_ENV&&console.warn(this.constructor.name+"的属性"+r+"传入参数类型不对"),t.hasOwnProperty(r)&&void 0!==t[r]&&(this[r]=t[r])}return this}},{key:"_getTypeOfValue",value:function(t){return"object"===(void 0===t?"undefined":o(t))?"[object Array]"===Object.prototype.toString.call(t)?"array":"object":void 0===t?"undefined":o(t)}},{key:"_checkEmpty",value:function(t,e,r){var n=void 0===r?"undefined":o(r),i=function(){"development"===process.env.NODE_ENV&&console.warn(t+"的属性"+e+"值不能为空")};({string:function(){""===r.replace(/(^\s*)|(\s*$)/g,"")&&i()},number:function(){(null==r||isNaN(r))&&i()},object:function(){(!r.length||0===r.length)&&i()}})[n]()}}]),t}();
/**
 *MD5加密
 */
/* eslint-disable */
/**
 * 参数类型
 * @type {{String: string, Number: string, Object: string, Array: string}}
 */
var b=require("js-base64").Base64;t.StringUtils=e,t.ArrayUtils=n,t.DateUtils=c,t.GeneralUtils=h,t.JsonUtils=f,t.ObjectUtils=d,t.StorageUtils=l,t.Cookie=m,t.Md5=y,t.Base64=b,t.RCModel=v,t.Check=
/**
 * 检验model的属性
 * @param type - 参数类型
 * @returns {Function}
 * @constructor
 */
function(n){return function(t,e,r){
// let v = descriptor.initializer && descriptor.initializer.call(this);
/** 将属性名字以及需要的类型的对应关系记录到类的原型上 */
return t.constructor.__checkers__||
// 将这个隐藏属性定义成 not enumerable，遍历的时候是取不到的。
Object.defineProperty(t.constructor,"__checkers__",{value:{},enumerable:!0,writeable:!0,configurable:!0}),t.constructor.__checkers__[e]={type:n},a({},r,{configurable:!0})}},t.CheckType={String:"string",Number:"number",Object:"object",Array:"array"},Object.defineProperty(t,"__esModule",{value:!0})});